package in.ocsf.frei.geld.core.model;/* kpmy 15.11.2017 */

import in.ocsf.frei.geld.core.model.aspects.*;
import org.bson.types.ObjectId;
import org.springframework.data.annotation.Id;
import org.springframework.data.annotation.Version;
import org.springframework.data.mongodb.core.mapping.DBRef;
import org.springframework.data.mongodb.core.mapping.Document;

@Document(collection = "dwarf")
public class Dwarf {

    @Id
    private ObjectId id;

    @Version
    private Long _version;

    private Integer age;

    private Integer death;

    private DwarfState state;

    private Integer day;

    private Integer hour;

    private String name;

    private EnergyAspect energy;

    private ActivityAspect activity;

    private FeelingsAspect feelings;

    private VisionAspect vision;

    private TaskAspect tasks;

    private ManagerAspect manager;

    private DecisionAspect decision;

    private RunnerAspect runner;

    @DBRef
    private World world;

    public Dwarf() {
    }

    public static Dwarf getInstance(World world) {
        Dwarf ret = new Dwarf();
        ret.world = world;
        ret.energy = EnergyAspect.getInstance();
        ret.activity = ActivityAspect.getInstance();
        ret.feelings = FeelingsAspect.getInstance();
        ret.vision = VisionAspect.getInstance();
        ret.tasks = TaskAspect.getInstance();
        ret.manager = ManagerAspect.getInstance();
        ret.decision = DecisionAspect.getInstance();
        ret.runner = RunnerAspect.getInstance();
        return ret;
    }

    public ManagerAspect getManager() {
        return manager;
    }

    public void setManager(ManagerAspect manager) {
        this.manager = manager;
    }

    public TaskAspect getTasks() {
        return tasks;
    }

    public void setTasks(TaskAspect tasks) {
        this.tasks = tasks;
    }

    public VisionAspect getVision() {
        return vision;
    }

    public void setVision(VisionAspect vision) {
        this.vision = vision;
    }

    public EnergyAspect getEnergy() {
        return energy;
    }

    public void setEnergy(EnergyAspect energy) {
        this.energy = energy;
    }

    public ActivityAspect getActivity() {
        return activity;
    }

    public void setActivity(ActivityAspect activity) {
        this.activity = activity;
    }

    public FeelingsAspect getFeelings() {
        return feelings;
    }

    public void setFeelings(FeelingsAspect feelings) {
        this.feelings = feelings;
    }

    public DwarfState getState() {
        return state;
    }

    public void setState(DwarfState state) {
        this.state = state;
    }

    public Integer getDeath() {
        return death;
    }

    public void setDeath(Integer death) {
        this.death = death;
    }

    public String getId() {
        return id.toHexString();
    }

    public void setId(ObjectId id) {
        this.id = id;
    }

    public Integer getAge() {
        return age;
    }

    public void setAge(Integer age) {
        this.age = age;
    }

    public Integer getDay() {
        return day;
    }

    public void setDay(Integer day) {
        this.day = day;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public World getWorld() {
        return world;
    }

    public void setWorld(World world) {
        this.world = world;
    }

    public Integer getHour() {
        return hour;
    }

    public void setHour(Integer hour) {
        this.hour = hour;
    }

    public DecisionAspect getDecision() {
        return decision;
    }

    public void setDecision(DecisionAspect decision) {
        this.decision = decision;
    }

    public RunnerAspect getRunner() {
        return runner;
    }

    public void setRunner(RunnerAspect runner) {
        this.runner = runner;
    }
}
