package in.ocsf.frei.geld.core.model.aspects;/* kpmy 25.11.2017 */

import in.ocsf.frei.geld.core.model.Dwarf;
import in.ocsf.frei.geld.core.model.DwarfContext;
import in.ocsf.frei.geld.core.model.SimpleEvent;

import java.util.function.BiConsumer;

public class ActivityAspect implements DwarfAspect {

    private boolean active;

    public ActivityAspect() {
    }

    public static ActivityAspect getInstance() {
        ActivityAspect ret = new ActivityAspect();
        ret.active = true;
        return ret;
    }

    @Override
    public BiConsumer<DwarfContext, Dwarf> perform() {
        return (ctx, dwarf) -> {
            if (ctx.hasSimpleEvent(SimpleEvent.SLEEP)) {
                active = false;
                ctx.doneWith(SimpleEvent.SLEEP);
            } else if (ctx.hasSimpleEvent(SimpleEvent.AWAKE)) {
                active = true;
                ctx.doneWith(SimpleEvent.AWAKE);
            }
        };
    }

    public boolean isActive() {
        return active;
    }

    public void setActive(boolean active) {
        this.active = active;
    }
}
