package in.ocsf.frei.geld.core.model.aspects;/* kpmy 25.11.2017 */

import com.fasterxml.jackson.annotation.JsonIgnore;
import org.apache.commons.lang3.RandomStringUtils;
import org.apache.commons.math3.complex.Complex;
import org.apache.commons.math3.complex.ComplexFormat;

public class DwarfTaskDescriptor {

    private String id;

    private DwarfTask task;

    private String value;

    public DwarfTaskDescriptor() {
    }

    public static DwarfTaskDescriptor getInstance(DwarfTask task, Complex value) {
        DwarfTaskDescriptor ret = new DwarfTaskDescriptor();
        ret.id = RandomStringUtils.randomAlphanumeric(10);
        ret.setComplexValue(value);
        ret.task = task;
        return ret;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public DwarfTask getTask() {
        return task;
    }

    public void setTask(DwarfTask task) {
        this.task = task;
    }

    @JsonIgnore
    public Complex getComplexValue() {
        return ComplexFormat.getInstance().parse(value);
    }

    public void setComplexValue(Complex value) {
        this.value = ComplexFormat.getInstance().format(value);
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }
}
