package in.ocsf.frei.geld.core.model.aspects;/* kpmy 25.11.2017 */

import in.ocsf.frei.geld.core.model.Dwarf;
import in.ocsf.frei.geld.core.model.DwarfContext;
import in.ocsf.frei.geld.core.model.LiveCycle;

import java.util.function.BiConsumer;

public class FeelingsAspect implements DwarfAspect {

    private static final int HUNGER_DAYS = 3;

    private double hunger;

    public FeelingsAspect() {

    }

    public static FeelingsAspect getInstance() {
        FeelingsAspect ret = new FeelingsAspect();
        ret.hunger = 0.0;
        return ret;
    }

    public double getHunger() {
        return hunger;
    }

    public void setHunger(double hunger) {
        this.hunger = hunger;
    }

    @Override
    public BiConsumer<DwarfContext, Dwarf> perform() {
        return (ctx, d) -> {
            this.hunger = (Math.min(HUNGER_DAYS * LiveCycle.DAYLY_ENERGY, LiveCycle.TOTAL_ENERGY - d.getEnergy().getEnergy()) / (HUNGER_DAYS * LiveCycle.DAYLY_ENERGY)) * 100;
        };
    }
}
