package in.ocsf.frei.geld.core.model.aspects;/* kpmy 25.11.2017 */

import in.ocsf.frei.geld.core.model.Dwarf;
import in.ocsf.frei.geld.core.model.DwarfContext;
import org.apache.commons.math3.complex.Complex;

import java.util.HashMap;
import java.util.Map;
import java.util.Optional;
import java.util.function.BiConsumer;
import java.util.function.Function;

public class TaskAspect implements DwarfDefaultAspect {

    public static final DwarfTaskDescriptor REST = DwarfTaskDescriptor.getInstance(DwarfTask.REST, DwarfTask.REST.getValue());
    private static Function<Dwarf, Complex> hungerF = (dwarf -> Complex.valueOf(dwarf.getFeelings().getHunger() / 100, 0).add(DwarfTask.EAT.getValue()));
    //комплексное число обозначает противоречие приятного и полезного
    private Map<DwarfTask, DwarfTaskDescriptor> queue;

    public TaskAspect() {
    }

    public static TaskAspect getInstance() {
        TaskAspect ret = new TaskAspect();
        ret.queue = new HashMap<>();
        return ret;
    }

    public Map<DwarfTask, DwarfTaskDescriptor> getQueue() {
        return queue;
    }

    public void setQueue(Map<DwarfTask, DwarfTaskDescriptor> queue) {
        this.queue = queue;
    }

    @Override
    public BiConsumer<DwarfContext, Dwarf> perform() {
        return (ctx, dwarf) -> {
            if (queue.isEmpty()) queue.put(DwarfTask.REST, REST);
            queue.put(DwarfTask.EAT, Optional.ofNullable(queue.get(DwarfTask.EAT)).map(t -> {
                t.setComplexValue(hungerF.apply(dwarf));
                return t;
            }).orElse(DwarfTaskDescriptor.getInstance(DwarfTask.EAT, hungerF.apply(dwarf))));
        };
    }
}
