package in.ocsf.frei.geld.core.model.aspects;/* kpmy 25.11.2017 */

import in.ocsf.frei.geld.core.model.Dwarf;
import in.ocsf.frei.geld.core.model.DwarfContext;
import in.ocsf.frei.geld.core.model.World;
import in.ocsf.frei.geld.core.model.WorldObjectType;
import org.apache.commons.lang3.tuple.MutablePair;
import org.springframework.data.mongodb.core.mapping.DBRef;

import java.util.HashMap;
import java.util.Map;
import java.util.function.BiConsumer;
import java.util.function.Consumer;
import java.util.stream.Collectors;

public class VisionAspect implements DwarfDefaultAspect {

    private Map<String, MutablePair<WorldObjectType, Object>> frame;

    @DBRef
    private World.DwarfPoint self;

    public VisionAspect() {
    }

    public static VisionAspect getInstance() {
        VisionAspect ret = new VisionAspect();
        ret.frame = new HashMap<>();
        return ret;
    }

    public Map<String, MutablePair<WorldObjectType, Object>> getFrame() {
        return frame;
    }

    public void setFrame(Map<String, MutablePair<WorldObjectType, Object>> frame) {
        this.frame = frame;
    }

    @Override
    public Consumer<Dwarf> skip() {
        return (d) -> frame = new HashMap<>();
    }

    public World.DwarfPoint getSelf() {
        return self;
    }

    public void setSelf(World.DwarfPoint self) {
        this.self = self;
    }

    @Override
    public BiConsumer<DwarfContext, Dwarf> perform() {
        return (ctx, dwarf) -> {
            self = ctx.getDwarfPosition(dwarf);
            frame = ctx.getAllAround(self).stream().filter(s -> !s.getPoint().equals(self.getPoint())).collect(Collectors.toMap(s -> s.getPoint().toString(), World.Something::getRef, (same, key) -> same));
        };
    }
}
