package in.ocsf.frei.geld.core.rest;/* kpmy 06.11.2017 */

import in.ocsf.frei.geld.core.misc.DwarfNames;
import in.ocsf.frei.geld.core.model.*;
import in.ocsf.frei.geld.core.repo.DwarfRepository;
import in.ocsf.frei.geld.core.repo.WorldObjectRepository;
import in.ocsf.frei.geld.core.repo.WorldRepository;
import in.ocsf.frei.geld.core.service.LiveCycleService;
import org.springframework.data.mongodb.core.MongoOperations;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.inject.Inject;
import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("dev")
public class DevController {

    @Inject
    private WorldRepository worldRepo;

    @Inject
    private DwarfRepository dwarfRepo;

    @Inject
    private WorldObjectRepository objectRepo;

    @Inject
    private LiveCycleService liveCycleService;

    @Inject
    private MongoOperations mongo;

    @RequestMapping(value = "reset", method = RequestMethod.POST)
    public void reset() {
        mongo.dropCollection(World.class);
        mongo.dropCollection(Dwarf.class);
        mongo.dropCollection(World.Something.class);

        World world = worldRepo.save(new World());
        loadMap(world, WorldMaps.HEAVEN);
        for (int i = 0; i < 1; i++) {
            Dwarf dwarf = Dwarf.getInstance(world);
            dwarf.setName(DwarfNames.getRandomName());
            dwarf.setAge(18);
            dwarf.setDeath(Long.valueOf(50 + Math.round(25 * Math.random())).intValue());
            dwarf.setState(DwarfState.mature);
            dwarf.setDay(Long.valueOf(Math.max(1, Math.round(LiveCycle.DAYS * Math.random()))).intValue());
            dwarf.setHour(0);
            dwarfRepo.save(dwarf);
            objectRepo.save(new World.DwarfPoint(world, dwarf, i * i, i * i));
        }

        for (int y = 0; y < 1; y++) {
            liveCycleService.run();
        }
    }

    private void loadMap(World world, String map) {
        int row = 0;
        int col = 0;
        List<World.Something> list = new ArrayList<>();
        for (int i = 0; i < map.length(); i++) {
            switch (map.charAt(i)) {
                case 'E':
                    row++;
                    break;
                case 'F':
                    World.FoodPoint point = new World.FoodPoint(world, row, col);
                    list.add(point);
                    row++;
                    break;
                default:
                    row = 0;
                    col++;
            }
        }
        objectRepo.save(list);
    }

}
