package in.ocsf.frei.geld.core.service;/* kpmy 15.11.2017 */

import in.ocsf.frei.geld.core.model.*;
import in.ocsf.frei.geld.core.model.aspects.DwarfAspect;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;

import javax.inject.Inject;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;
import java.util.stream.Stream;

@Service
public class DwarfService {

    @Inject
    private WorldService worldService;

    @Inject
    private ApplicationContext applicationContext;

    public void runDwarfHour(World world, Dwarf dwarf) {
        DwarfContext context = new DwarfContext(applicationContext);
        context.setHour(world.getHour());
        for (DwarfAspect aspect : getAspects(dwarf)) {
            if (aspect.isAvailable().apply(context, dwarf))
                aspect.perform().accept(context, dwarf);
            else
                aspect.skip().accept(dwarf);
            if (context.hasSimpleEvent(SimpleEvent.DEATH)) {
                dwarf.setState(DwarfState.dead);
                return;
            }
        }
    }

    private List<DwarfAspect> getAspects(Dwarf dwarf) {
        return Stream.of(dwarf.getEnergy(),
                dwarf.getFeelings(),
                dwarf.getActivity(),
                dwarf.getVision(),
                dwarf.getTasks(),
                dwarf.getManager(),
                dwarf.getDecision(),
                dwarf.getRunner())
                .filter(Objects::nonNull)
                .collect(Collectors.toList());
    }

}
